#!/usr/bin/env node

// WebSocket example - backend - from:
// https://github.com/rsp/node-websocket-vs-socket.io
// Copyright (c) 2015, 2016 Rafał Pocztarski
// Released under MIT License (Expat) - see:
// https://github.com/rsp/node-websocket-vs-socket.io/blob/master/LICENSE.md

/*eslint-disable no-loop-func*/
var path = require('path');
var http = require('http');
var app = require('express')();
var ws = require('express-ws')(app);
app.get('/', (req, res) => {
  console.error('express connection');
  res.sendFile(path.join(__dirname, 'ws.html'));
});
app.ws('/', (s, req) => {
  console.error('websocket connection');
  for (var t = 0; t < 3; t++)
    setTimeout(() => s.send('message from server', ()=>{}), 1000*t);
});
app.on('error', err => {
  console.error('error:', err);
  process.exit(1);
});

var server = http.createServer(app);
var port = 3001;
server.on('listening', () => 
  console.error('listening on http://localhost:'+port+'/'));
server.on('error', err => {
  if (err.code === 'EADDRINUSE') {
    console.error('port '+port+' in use');
    server.listen(++port);
  } else {
    console.error('error:', err);
    process.exit(1);
  }
});
server.listen(port);

console.error('websocket example');

